Decoder_DLL	=%A_ScriptDir%\B25Decoder_d.dll
Driver_DLL	=%A_ScriptDir%\SegDriver_hdus.dll

UDP_Addr	=127.0.0.1
UDP_Port	=1234

Save_Dir	=F:\capture_hdus

VLC_Path	=%A_ScriptDir%\..\VLC\vlc.exe
VLC_Options	=--deinterlace-mode blend
VLC_Maximize =1

Channel_Count=8
Channel_1_Name=NHK
Channel_1_Value=18
Channel_2_Name=NHK
Channel_2_Value=19
Channel_3_Name=
Channel_3_Value=
Channel_4_Name={er
Channel_4_Value=25
Channel_5_Name=er
Channel_5_Value=24
Channel_6_Name=TBS
Channel_6_Value=22
Channel_7_Name=er
Channel_7_Value=23
Channel_8_Name=tWer
Channel_8_Value=21

Default_Channel=7



Loop,%Channel_Count%{
	if(Channel_%A_Index%_Value){
		Menu,ChannelMenu,Add,% Channel_%A_Index%_Name,MenuChannelProc
	}else{
		Menu,ChannelMenu,Add
	}
}
Menu,Tray,NoStandard
Menu,Tray,DeleteAll
Menu,Tray,Add,VLC\(&V),MenuVLCProc
Menu,Tray,Add,``l(&C),:ChannelMenu
;Menu,Tray,Add,NCbN^(&R),MenuRecProc
;Menu,Tray,Add,Ow^(&S),MenuSaveProc
;Menu,Tray,Add,^~(&T),MenuStopRecProc
;Menu,Tray,Disable,^~(&T)
;Menu,Tray,Add,I(&X),MenuExitProc
Menu,Tray,Standard
Menu,Tray,Default,VLC\(&V)


DllCall("ole32.dll\CoInitialize","UInt",0,"UInt")
hSocket:=UDP_Client_Create(UDP_Addr,UDP_Port)
hDecoder:=Decoder_Initialize(Decoder_DLL,4)
hDevice:=SegDriver_Initialize(Driver_DLL,RegisterCallback("ReceiveTSStream"))

SegDriver_Activate(hDevice,SegDriver_GetTunerID(0))
SegDriver_Tune(hDevice,ChToMHz(Channel_%Default_Channel%_Value))
Channel_Tuned:=Default_Channel
TrayTip,N
OnExit,OnExitProc

return ;;;;;;;;;;;;;;;;;;;;;;;;;;;;; END OF INITIALIZE SECTION;;;;;;;;;;;;;;;;;;;;;;;;;

RunVLC(file=""){
	global
	if(!file){
		file=udp:@%UDP_Addr%:%UDP_Port%
	}
	Run,%VLC_Path% %file% %VLC_Options%,,Max,VLC_PID
}

MenuVLCProc:
	Process,Exist,%VLC_PID%
	if(VLC_PID && ErrorLevel){
		WinActivate,ahk_pid %VLC_PID%
	}else{
		if(hSaveFile && GetKeyState("Shift")){
			RunVLC(SaveFile)
		}else{
			RunVLC()
		}
		if(VLC_Maximize){
			WinWait,ahk_pid %VLC_PID%
			WinMaximize
		}
	}
return

MenuExitProc:
ExitApp

MenuChannelProc:
	if(hSaveFile){
		TrayTip,^撆ɂA`lł܂
	}else{
		SegDriver_Tune(hDevice,ChToMHz(Channel_%A_ThisMenuItemPos%_Value))
		Channel_Tuned:=A_ThisMenuItemPos
	}
return

ReceiveTSStream(drv,pBuf,size){
	local dBuf,dSize
	Critical
	Decoder_Decode(hDecoder,pBuf,size,dBuf,dSize)
	if(dBuf){
		if(hSaveFile){
			WriteFile(hSaveFile,dBuf,dSize)
		}
		if(hSocket){
			UDP_Client_Send(hSocket,dBuf,dSize)
		}
	}
}

OnExitProc:
	if(hSegDriverDLL){
		if(hDevice){
			SegDriver_Deactivate(hDevice)
			SegDriver_Release(hDevice)
		}
	}
	if(VLC_PID){
		Process,Close,%VLC_PID%
	}
	if(hDecoder){
		Decoder_Release(hDecoder)
	}
	if(hSocket){
		UDP_Client_Release(hSocket)
	}
ExitApp




/*
	Provide UDP Stream
*/
UDP_Client_Create(addr,port){
	local handle,ad
	if(!WS_Data){
		hWs2_32DLL:=LoadLibrary("Ws2_32.dll")
		pWSAStartup:=GetProcAddress(hWs2_32DLL,"WSAStartup")
		WS_Data:=Malloc(400)
		DllCall(pWSAStartup,"UShort",0x02,"UInt",WS_Data)
		pSocket:=GetProcAddress(hWs2_32DLL,"socket")
		pCloseSocket:=GetProcAddress(hWs2_32DLL,"closesocket")
		
		pConnect:=GetProcAddress(hWs2_32DLL,"connect")
		pSend:=GetProcAddress(hWs2_32DLL,"send")
		pWSAStringToAddress:=GetProcAddress(hWs2_32DLL,"WSAStringToAddressA")
		pHtoNs:=GetProcAddress(hWs2_32DLL,"htons")
	}
	handle:=DllCall(pSocket,"UInt",2,"UInt",2,"UInt",17)
	ad:=Malloc(16)
	NumPut(2,ad+0,0,"Short")
	DllCall(pWSAStringToAddress,"Str",addr, "UInt",2, "UInt",0, "UInt",ad, "UIntP",16)
	NumPut(DllCall(pHtoNs,"UShort",port),ad+0,2,"UShort")
	DllCall(pConnect,"UInt",handle, "UInt",ad, "UInt",16)
	return handle
}
UDP_Client_Finalize(){
	global
	DllCall("wsock32.dll\WSACleanup")
	WS_Data=
}
UDP_Client_Release(sock){
	global
	DllCall(pCloseSocket,"UInt",sock)
}
UDP_Client_Send(sock,pBuf,size){
	global
	DllCall(pSend,"UInt",sock,"UInt",pBuf,"UInt",size,"Int",0)
}

/*
	Save to File
*/
CreateFile(path){
	hf:= DllCall("kernel32.dll\CreateFileA", "Str",path, "UInt", 0x40000000|0x80000000, "UInt",1, "UInt", 0, "UInt", 4, "UInt",0, "UInt",0)
	DllCall("kernel32.dll\SetFilePointer","UInt",hf, "UInt",0, "UInt",0, "UInt",2)
	return hf
}
WriteFile(hf,buf,size){
	DllCall("kernel32.dll\WriteFile", "UInt", hf, "UInt", buf, "UInt", size, "UIntP", WrittenBytes, "UInt", 0)
}
CloseFile(hf){
	DllCall("kernel32.dll\CloseHandle","UInt",hf)
}


/*
	Decoder
*/
Decoder_Initialize(DecoderDLL,option){
	local hDecoder
	if(!hDecoderDLL){
		hDecoderDLL:=LoadLibrary(DecoderDLL)
		pDecoder_Create:=GetProcAddress(hDecoderDLL,"CreateB25Decoder")
		pDecoder_Initialize:=GetProcAddress(hDecoderDLL,"B25Decoder_Initialize")
		pDecoder_Release:=GetProcAddress(hDecoderDLL,"B25Decoder_Release")
		pDecoder_Decode:=GetProcAddress(hDecoderDLL,"B25Decoder_Decode")
		pDecoder_Flush:=GetProcAddress(hDecoderDLL,"B25Decoder_Flush")
		pDecoder_Reset:=GetProcAddress(hDecoderDLL,"B25Decoder_Reset")
	}
	hDecoder:=DllCall(pDecoder_Create,"CDecl")
	DllCall(pDecoder_Initialize,"UInt",hDecoder,"UInt",option,"CDecl Int")
	return hDecoder
}
Decoder_Release(hd){
	global
	DllCall(pDecoder_Release,"UInt",hd,"CDecl UInt")
}
Decoder_Decode(hd,pSrc,dwSize,ByRef pDest,ByRef dwDestSize){
	global
	return DllCall(pDecoder_Decode,"UInt",hd,"UInt",pSrc,"UInt",dwSize,"UIntP",pDest,"UIntP",dwDestSize,"CDecl UInt")
}
Decoder_Flush(hd,pSrc,dwSize,ByRef pDest,ByRef dwDestSize){
	global
	return DllCall(pDecoder_Flush,"UInt",hd,"UIntP",pDest,"UIntP",dwDestSize,"CDecl UInt")
}
Decoder_Reset(hd){
	global
	return DllCall(pDecoder_Reset,"UInt",hd,"CDecl UInt")
}



/*
	Control Devices
*/
SegDriver_Initialize(dllname,callback=0){
	local hd,pCallback
	if(!hSegDriverDLL){
		hSegDriverDLL:=LoadLibrary(dllname)
		pSegDriver_MakeDriverInstance	:=GetProcAddress(hSegDriverDLL,"MakeDriverInstance")
		pSegDriver_FreeDriverInstance	:=GetProcAddress(hSegDriverDLL,"FreeDriverInstance")
		pSegDriver_GetTunerCount		:=GetProcAddress(hSegDriverDLL,"GetTunerCount")
		pSegDriver_GetTunerID			:=GetProcAddress(hSegDriverDLL,"GetTunerID")
		pSegDriver_GetTunerName			:=GetProcAddress(hSegDriverDLL,"GetTunerName")
		pSegDriver_Activate				:=GetProcAddress(hSegDriverDLL,"Activate")
		pSegDriver_Deactivate			:=GetProcAddress(hSegDriverDLL,"Deactivate")
		pSegDriver_Tune					:=GetProcAddress(hSegDriverDLL,"Tune")
		pSegDriver_SetReceiveTSCallback	:=GetProcAddress(hSegDriverDLL,"SetReceiveTSCallback")
	}
	hd:=DllCall(pSegDriver_MakeDriverInstance)
	
	if(callback){
		pCallback:=DllCall("kernel32.dll\VirtualAlloc","UInt",0,"Int",16,"UInt",0x1000,"UInt",0x40,"UInt")
		NumPut(0x8B,pCallback+0,0,"UChar")			;mov
		NumPut(0x44,pCallback+0,1,"UChar")			;    eax
		NumPut(0x24,pCallback+0,2,"UChar")			;       ,esp
		NumPut(0x04,pCallback+0,3,"UChar")			;            +4
		NumPut(0x50,pCallback+0,4,"UChar")			;push eax
		NumPut(0x51,pCallback+0,5,"UChar")			;push ecx
		NumPut(0x52,pCallback+0,6,"UChar")			;push edx
		NumPut(0xB8,pCallback+0,7,"UChar")			;mov eax
		NumPut(callback,pCallback+0,8,"UInt")	;        func
		NumPut(0xFF,pCallback+0,12,"UChar")			;call
		NumPut(0xD0,pCallback+0,13,"UChar")			;     eax
		NumPut(0xC2,pCallback+0,14,"UChar")			;ret
		NumPut(0x04,pCallback+0,15,"UChar")			;    4
		DllCall(pSegDriver_SetReceiveTSCallback,"UInt",hd,"UInt",pCallback)
	}
	return hd
}

SegDriver_GetTunerCount(){
	global
	return DllCall(pSegDriver_GetTunerCount)
}

SegDriver_GetTunerID(idx){
	local buf
	VarSetCapacity(buf,1023,0)
	DllCall(pSegDriver_GetTunerID,"UInt",idx, "Str",buf, "UInt", 1024)
	return buf
}

SegDriver_Release(hd){
	global
	DllCall(pSegDriver_FreeDriverInstance,"UInt",hd)
}

SegDriver_Tune(hd,mhz){
	global
	return DllCall(pSegDriver_Tune,"UInt",hd,"UInt",mhz*1000)
}


SegDriver_Activate(hd,tunerid){
	global
	return DllCall(pSegDriver_Activate,"UInt",hd,"Str",tunerid)
}
SegDriver_Deactivate(handle){
	global
	return DllCall(pSegDriver_Deactivate,"UInt",handle)
}



ChToMHz(ch){
	if(RegExMatch(ch,"^\d+$")){
		if(ch>=13 && ch <=62){
			return 473+(ch-13)*6
		}
	}else if(RegExMatch(ch,"^C\d+$")){
		ch:=RegExReplace(ch,"^C","")
		if(ch>=23 && ch<=63){
			return 222+(ch-23)*6 + (ch>=24 && ch<=28) ? 2 : 0
		}
	}
	return -1
}


/*
	DynaCall Utils
*/
LoadLibrary(name){
	return DllCall("kernel32.dll\LoadLibraryA","Str",name,"UInt")
}
GetProcAddress(hDLL,name){
	return DllCall("kernel32.dll\GetProcAddress","UInt",hDLL,"Str",name,"UInt")
}
FreeLibrary(hDLL){
	return DllCall("kernel32.dll\FreeLibrary","UInt",hDLL,"Int")
}
Malloc(size,flag=0x40){
	return DllCall("kernel32.dll\GlobalAlloc","UInt",flag,"UInt",size,"UInt")
}
Free(p){
	DllCall("kernel32.dll\GlobalFree",UInt,p,UInt)
}



#NoEnv
#Persistent
